<?php

namespace Drupal\stackla_widget\Api;

/**
 * The Stack Class.
 *
 * @package Drupal\stackla_widget\Api
 */
class Stack {

  /**
   * Config.
   *
   * @var array
   */
  protected $configs;

  /**
   * Instantiated Stackla object.
   *
   * @param \Drupal\stackla_widget\Api\Credentials $credentials
   *   The credentials object.
   * @param string $host
   *   The host.
   * @param string $stack
   *   The stack.
   */
  public function __construct(Credentials $credentials, string $host = '', string $stack = '') {
    $this->configs = [
      'credentials' => $credentials,
      'host' => $host,
      'stack' => $stack,
    ];
  }

  /**
   * Instantiated new object.
   *
   * @param string $objectName
   *   The object name, like widget.
   * @param string|array $objectId
   *   Id of new object.
   * @param bool $fetch
   *   Do get request to populate the field / property.
   *
   * @return object
   *   The object returned.
   */
  public function instance(string $objectName = '', string $objectId = NULL, bool $fetch = TRUE) {
    $class = "\\Drupal\\stackla_widget\\Api\\" . ucfirst($objectName);
    if (!class_exists($class)) {
      return NULL;
    }

    return new $class($this->configs, $objectId, $fetch);
  }

}
