<?php

namespace Drupal\stackla_widget\Api\Validation;

/**
 * The Json Validator Class.
 *
 * @package Stackla\Validation
 */
class JsonValidator {

  /**
   * Helper method for validating if string provided is a valid json.
   *
   * @param string $string
   *   String representation of Json object.
   * @param bool $silent
   *   Flag to not throw \InvalidArgumentException.
   *
   * @return bool
   *   The result.
   */
  public static function validate(string $string = '', bool $silent = FALSE) {
    if (intval($string) !== 0) {
      return FALSE;
    }
    @json_decode($string);
    if (json_last_error() != JSON_ERROR_NONE) {
      if ($silent == FALSE) {
        // Throw an Exception for string or array.
        throw new \InvalidArgumentException("Invalid JSON String");
      }
      return FALSE;
    }
    return TRUE;
  }

}
