<?php

namespace Drupal\stackla_widget\Api;

/**
 * The WidgetInterface Interface.
 *
 * @package Drupal\stackla_widget\Api
 */
interface WidgetInterface {

  /**
   * Widget type options.
   */
  const TYPE_FLUID = 'fluid';
  const TYPE_STATIC = 'fixed';

  // Fluid type only.
  const STYLE_VERTICAL_FLUID = 'fluid';
  // Fluid type only.
  const STYLE_HORIZONTAL_FUILD = 'horizontal-fluid';
  // Static type only.
  const STYLE_CAROUSEL = 'carousel';
  // Static type only.
  const STYLE_SCROLL = 'main';
  // Static type only.
  const STYLE_SLIDESHOW = 'slideshow';
  // Fluid type only.
  const STYLE_BASE_WATERFALL = 'base_waterfall';
  // Fluid type only.
  const STYLE_BASE_CAROUSEL = 'base_carousel';
  // Fixed type only.
  const STYLE_BASE_FEED = 'base_feed';
  // Fixed type only.
  const STYLE_BASE_BILLBOARD = 'base_billboard';
  // Fixed type only.
  const STYLE_BASE_SLIDESHOW = 'base_slideshow';

  /**
   * Method will create a new widget that is cloned from current Widget.
   *
   * @return bool|mixed
   *   Method will return a new widget object or False if failed.
   */
  public function duplicate();

  /**
   * Method will create a widget with inherited style from parent widget.
   *
   * @param int $filter_id
   *   Filter id for the inherited widget.
   * @param string $name
   *   Widget name for inherited widget.
   *
   * @return bool|mixed
   *   Method will return a widget object or false if failed.
   */
  public function derive(int $filter_id, string $name);

}
