<?php

namespace Drupal\stackla_widget\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FormatterBase;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin implementation of the 'stackla_widget_formatter' formatter.
 *
 * @FieldFormatter(
 *   id = "stackla_widget_formatter",
 *   module = "stackla_widget",
 *   label = @Translation("Stackla widget formatter"),
 *   field_types = {
 *     "stackla_widget"
 *   }
 * )
 */
class StacklaWidgetFormatter extends FormatterBase {

  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = [];

    foreach ($items as $delta => $item) {
      $elements[$delta] = [
        '#theme' => 'stackla_widget_formatter',
        '#embed' => $item->iframe,
      ];
    }

    return $elements;
  }

}
